MODULE_NAME='VAV_!MyWeatherMod1' ( DEV dvRSS,DEV vSitrep_Client,CHAR sCityData[][],
				   DEV dvUI_Arry[],INTEGER nUI_TypeArry[],INTEGER nUI_WXActiveArry[],INTEGER nBtnArry[],INTEGER nFeedback[],
				   INTEGER nRefreshTime,INTEGER nWindSpeed,INTEGER nWindGusts,INTEGER nWx_HoldSitRep,INTEGER nWx_DeBug)
				   
(***********************************************************)
(*  FILE CREATED ON: 08/05/2006  AT: 12:02:51              *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 07/03/2008  AT: 14:27:53        *)
(***********************************************************)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*	/////        /////   /////   /////        /////    *)
(*	  //          //     // //     //          //      *)
(*	   //        //     //   //     //        //       *)
(*	    //      //     /////////     //      //        *)
(*	     //    //     //       //     //    //         *)
(*	      //  //     //         //     //  //          *)
(*	       ////    /////      /////     ////           *)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)

//#DEFINE VAV_WEATHER_MODULE
//
//#INCLUDE 'VAV_Weather_Settings'

(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)

DEFINE_CONSTANT // FILENAME to Hold weather data for email

CHAR RSS_WEATHER_CURFILE[] = 'RSSWeather_Return.txt' ;//\files\

DEFINE_CONSTANT //TIMELINES

TL_RefreshWeatherFB     = 1 ;

DEFINE_CONSTANT //INCLUDES

#INCLUDE 'VAV_SYSTEM_CONSTANTS.axi'
#INCLUDE 'VAV_SITREP_ModClient.axi'      // Include to send notifications

DEFINE_CONSTANT

REFRESH_TIME     = 60 ;
TRUE             = 1 ;
FALSE            = 0 ;
CLIENT_ONLINE	 = 1 ;
CLIENT_OFFLINE	 = 0 ;
SERVER_ONLINE	 = 2 ;
TCP              = 1 ;
UDP         	 = 2 ;
ClientOnline     = 12 ;
//LF               = {$0A} ;
//STR_CRLF[2]          = {$0D,$0A} ;

VT_lastupdate    = 1 ;
VT_title         = 2 ;
VT_rcvdzip       = 3 ;
VT_overview      = 4 ;
VT_description   = 5 ;
VT_icon          = 6 ;
VT_pubdate       = 7 ;
VT_humidity      = 8 ;
VT_windspeed     = 9 ;
VT_winddir       = 10 ;
VT_gusts         = 11 ;
VT_pressure      = 12 ;
VT_dewpoint      = 13 ;
VT_heatindex     = 14 ;
VT_windchill     = 15 ;
VT_visibility    = 16 ;
VT_fcastTitle_1	 = 17 ;
VT_forecast_1	 = 18 ;
VT_fcastTitle_2	 = 19 ;
VT_forecast_2    = 20 ;
VT_fcastTitle_3	 = 21 ;
VT_forecast_3    = 22 ;
VT_fcastTitle_4	 = 23 ;
VT_forecast_4    = 24 ;
VT_fcastTitle_5	 = 25 ;
VT_forecast_5    = 26 ;
WeatherIcon_Btn  = 27 ;

UI_UPDATE_ACTIVE 	= 0 ;

(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)

///////////////////////LICENSING STUFF  ////////////////////////////
CHAR LICENSE_KEY_FILENAME[]    = 'CLIENT_LICENSE_KEY_KEY.xml' ; // filename to store persistent data!
CHAR LICENSE_DATA_FILENAME[]   = 'CLIENT_LICENSE_KEY_DATA.xml' ; // filename to store persistent data!
				   //123456789012345678901234 = 24
CHAR CLIENT_LICENSE_STRING[24] = 'MALPESO-ZBX55DB4S17-VAV' ;  // key code !
CHAR LICENSE_EXPIRATION_DATE[] = '05/01/2011' ; // mm/dd/yyyy (always make 1st of the month) six months after schedule completion date
LONG LICENSE_READ_BUFLENGTH    = 1000 ; //actually uses 574 char string for xml file.
LICENSE_EXPIRATION_YEAR        = 2011 ; //back up for fixed date
LICENSE_EXPIRATION_MONTH       = 5 ; //back up for fixed date //this will always be effective 1st of month.
///////////////////////LICENSING STUFF  ////////////////////////////

(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)

DEFINE_TYPE

structure sRSSFields
     {
     char lastupdate [8]
     char title [50]
     char rcvdzip [5]
     char overview [75]
     char description [30]
     char icon [20]
     char pubdate [40]
     char humidity [4]
     char windspeed [7]
     char winddir [8]
     char gusts [7]
     char pressure [10]
     char dewpoint [4]
     char heatindex [4]
     char windchill [4]
     char visibility [5]
     }
structure sRSScity
     {
     char country [2]
     char county  [5]
     char state   [2]
     char city   [30]
     char zone    [6]
     char zip     [5]
     }
structure sRSSforecasts
     {
     char title [30]
     char description [400]
     }
structure sTime
     {
     char Hour [2]
     char Minute [2]
     char Seconds [2]
     }
     
structure sLicenseKeyKey
     {
     CHAR cLicenseKey[24] ;
     }
structure sLicenseKeyData
     {
     CHAR cLicenseDate[8] ;
     Sinteger nLicenseDay ;
     Sinteger nLicenseMonth ;
     Sinteger nLicenseYear ;
     Sinteger nLicenseHour ;
     Sinteger nLicenseDLFlag ;
     integer nLicenseDayCountDown ;
     Sinteger nLicenseMinute ;
     }
          
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)

DEFINE_VARIABLE

VOLATILE INTEGER nTest_Wx_SitRep = 0 ;
////////////////////////////////////////////////////////////
volatile sLicenseKeyKey sLicenseKey ;
volatile sLicenseKeyData sLicenseData ;
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
volatile sRSSFields sRSS ;
volatile sRSSFields sRSSsent ;
volatile sRSScity sCity ;
volatile sRSSforecasts sForecasts[5] ;
volatile sRSSforecasts sForecastsSent[5] ;
volatile char cRSSTrash [1000] ;
volatile char cRSSBuf [10000] ;
volatile char cRSSBuf_Notify [20000] ;
volatile LONG nWDataRefresh[1]= {(60 * 60000)} ;
VOLATILE INTEGER nGotDMS_KPs = 0 ;

(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*             SPECIAL WEATHER VARIABLES                   *)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)

 non_volatile char cWeatherBuff ;
 volatile char cWeather_Var_to_XML[LICENSE_READ_BUFLENGTH] ;

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// This function returns a string in the form of HH:MM with an input of the standard 24 hour TIME string variable 
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
(*
DEFINE_FUNCTION INTEGER fnFindDMS_KPs()

     {
     if(dvDMSWeatherArry[1].NUMBER < 12000)//just check 1st arry position
	  {
	  RETURN TRUE ;
	  }
	  
     RETURN FALSE ;
     }
*)
DEFINE_FUNCTION fnWx_DeBug(CHAR iStr[])

     {
     if(nWx_DeBug)
	  {
	  SEND_STRING 0,"'WEATHER MOD DEBUG: ',iStr"
	  }
     }
     
DEFINE_FUNCTION CHAR[8] fn24TimeTo12(CHAR s24Time[])

     {
     STACK_VAR CHAR sTemp[8] ;
     STACK_VAR CHAR sSuffix[3] ;
     STACK_VAR INTEGER nHour ;
     STACK_VAR INTEGER nMin ;
     STACK_VAR CHAR sMin[2] ;
     sTemp = s24Time ;
     nHour = ATOI(REMOVE_STRING(sTemp, "':'", 1)) ;
     nMin = ATOI(REMOVE_STRING(sTemp, "':'", 1)) ;
     SELECT
	  {
	  ACTIVE (nHour == 0) :
	       {
	       sSuffix = "' AM'" ;
	       nHour = 12 ;
	       }
	  ACTIVE (nHour < 12) :
	       {
	       sSuffix = "' AM'" ;
	       }
	  ACTIVE (nHour == 12) :
	       {
	       sSuffix = "' PM'" ;
	       }
	  ACTIVE (nHour > 12) :
	       {
	       sSuffix = "' PM'" ;
	       nHour = nHour - 12 ;
	       }
	  }
     sMin = RIGHT_STRING("'0', ITOA(nMin)", 2) ;
     
     RETURN "ITOA(nHour), ':', sMin, sSuffix" ;
     }
     
DEFINE_FUNCTION CHAR[2000] fnReplace(CHAR strSTR[], CHAR strSEARCH[], CHAR strREPLACE[])
     {
     STACK_VAR INTEGER nPOS
     STACK_VAR CHAR strTRASH[2000]
     STACK_VAR CHAR strTEMP_STR[2000]
     nPOS = FIND_STRING(strSTR, "strSEARCH", 1)
     IF (!nPOS)
	  RETURN strSTR;
     WHILE (nPOS)
	  {
	  strTEMP_STR = ""
	  IF (nPOS > 1)
	       strTEMP_STR = LEFT_STRING(strSTR, nPOS - 1)
	  strTRASH = REMOVE_STRING(strSTR, "strTEMP_STR, strSEARCH", 1)
	  strSTR = "strTEMP_STR, strREPLACE, strSTR"
	  nPOS = FIND_STRING(strSTR, "strSEARCH", nPOS + LENGTH_STRING(strREPLACE))
	  }
     RETURN strSTR;
     }
     
DEFINE_FUNCTION fnSendSitrep(INTEGER iRX_Values, INTEGER iSendFile)

     {
     if(!nWx_HoldSitRep)
	  {
	  STACK_VAR CHAR cFilePath[50] ;
	  
	  if(iSendFile)
	       {
	       cFilePath = "RSS_WEATHER_CURFILE" ;
	       fnFileWrite_ToFile(cFilePath,cRSSBuf) ;
	       }
	  else
	       {
	       cFilePath = '' ;
	       }
	       
	  IF(LENGTH_STRING(SITREP_DEFAULT_URL) && LENGTH_STRING(SITREP_USER) && LENGTH_STRING(SITREP_PASS))
	       {//use 2 single quote for fields not used.  for email sent all but file & body needs to be filled in
	        //if you want to send an attachment then all but body needs to be set.
	       fnSitrepQueMSG(
		    (*task*)'!SEND_SITREP!',
		    (*from*) "'Malpeso''s Weather Mod'",
		    (*url *) SITREP_DEFAULT_URL,
		    (*user*) SITREP_USER,
		    (*pass*) SITREP_PASS,
		    (*subj*) "'Malpeso''s Weather Mod rx (',itoa(iRX_Values),' of 20 values)'",
		    (*body*) "'Malpeso''s Weather Mod rx (',itoa(iRX_Values),' of 20 values)'",
	     (*attach file*) "cFilePath" //iFile is filename of current file prior to new day file name change
			      ) ;
	       }
	  }
     }
    
DEFINE_FUNCTION CHAR fnRSSParser(char iRSSBuf [10000])

     {
     local_var integer nRunOne ;
     stack_var integer nFBS
     stack_var integer n
     stack_var integer i
     i = 0
     if (find_string(iRSSBuf,"'<title>',sCity.city",1))
	  {// Kill the function around (time) if you prefer 24 hour time format
	  sRSS.lastupdate = fn24TimeTo12(time) 
	  nFBS = find_string(iRSSBuf,"'<title>',sCity.city",1)
	  if (nFBS)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf, nFBS + 6)
	       nFBS = find_string(iRSSBuf,'</title>',1)
	       sRSS.title = get_buffer_string(iRSSBuf, nFBS - 1)
	       i ++
	       }
	  else
	       {
	       sRSS.title = 'N/A'
	       }
	  nFBS = find_string(iRSSBuf,'/zipcode/',1)
	  if (nFBS)
	       {
	       cRSSTrash = remove_string(iRSSBuf,'/zipcode/',1)
	       nFBS = find_string(iRSSBuf,'/',1)
	       sRSS.rcvdzip = get_buffer_string(iRSSBuf, nFBS - 1)
	       i ++
	       }
	  else
	       {
	       i ++ ; //doesn't return a zip code so fake the number.
	       sRSS.rcvdzip = 'N/A'
	       }
	  nFBS = find_string(iRSSBuf,"'<title>',sCity.city",1) 
	  if (nFBS)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf, nFBS + 6)
	       nFBS = find_string(iRSSBuf,'</title>',1)
	       sRSS.overview = get_buffer_string(iRSSBuf, nFBS - 1)
	       i ++ ;
	       }
	  else
	       {
	       sRSS.overview = 'N/A'
	       }
	  nFBS = find_string(iRSSBuf,'<pubDate>',1)
	  if (nFBS)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf, nFBS + 8)
	       nFBS = find_string(iRSSBuf,'</pubDate>',1)
	       sRSS.pubDate = get_buffer_string(iRSSBuf, nFBS - 15)
	       i ++ ;
	       }
	  else
	       {
	       sRSS.pubDate = 'N/A'
	       }
	  nFBS = find_string(iRSSBuf,'<description>',1)
	  if (nFBS)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf, nFBS + 12)
	       nFBS = find_string(iRSSBuf,'</description>',1)
	       sRSS.description = get_buffer_string(iRSSBuf, nFBS - 1)
	       i ++ ;
	       }
	  else
	       {
	       sRSS.description = 'N/A'
	       }
	  nFBS = find_string(iRSSBuf,'/images/fcicons/',1) //added prefix "wicon_" to send_command for pic changes
	  if (nFBS)                                       //"all TP pic filenames are  "'wicon_',sRSS.icon,'.png'"
	       {                                         //only store the retrieved name less extension.
	       cRSSTrash = get_buffer_string(iRSSBuf, nFBS + 15)
	       nFBS = 0 ;
	       if(find_string(iRSSBuf,'.gif"',1))
		    {
		    nFBS = find_string(iRSSBuf,'.gif"',1) ;
		    }
	       else if(find_string(iRSSBuf,'.png"',1))
		    {
		    nFBS = find_string(iRSSBuf,'.png"',1) ;
		    }
	       //nFBS = find_string(iRSSBuf,'."',1) // use this if they use different types of images
	       if(nFBS)
		    {
		    sRSS.icon = get_buffer_string(iRSSBuf, nFBS - 1) ;
		    i ++ ;
		    }
	       else
		    {
		    sRSS.icon = 'N/A' ;
		    }
	       }
	  else
	       {
	       sRSS.icon = 'N/A'
	       }
	  nFBS = find_string(iRSSBuf,'<dt',1)
	  if(nFBS > 1)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf,nFBS -1) ;
	       }
	  if(find_string(iRSSBuf,'">Humidity:</dt>',1) && find_string(iRSSBuf,'</dd>',1))
	       {
	       STACK_VAR CHAR cRSS_StrTmp[255] ;
	       
	       //cRSSTrash = remove_string(iRSSBuf,'">Humidity:</dt>',1) ;
	       cRSS_StrTmp = remove_string(iRSSBuf,'</dd>',1) ;
	       cRSSTrash = remove_string(cRSS_StrTmp,'inline;">',1) ;
	       nFBS = find_string(cRSS_StrTmp,'</dd>',1) ;
	       sRSS.humidity = get_buffer_string(cRSS_StrTmp, nFBS - 1) ;
	       i ++ ;
	       }
	  else
	       {
	       sRSS.humidity = 'N/A' ;
	       }
	  nFBS = find_string(iRSSBuf,'<dt',1) ;
	  if(nFBS > 1)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf,nFBS -1) ;
	       }
	  if(find_string(iRSSBuf,'">Wind Speed:</dt>',1) && find_string(iRSSBuf,'</dd>',1))
	       {
	       STACK_VAR CHAR cRSS_StrTmp[255] ;
	       
	       //cRSSTrash = remove_string(iRSSBuf,'">Wind Speed:</dt>',1) ;
	       cRSS_StrTmp = remove_string(iRSSBuf,'</dd>',1) ;
	       cRSSTrash = remove_string(cRSS_StrTmp,'inline;">',1) ;
	       nFBS = find_string(cRSS_StrTmp,'</dd>',1) ;
	       sRSS.windspeed = get_buffer_string(cRSS_StrTmp, nFBS - 1) ;
	       nFBS = find_string(sRSS.windspeed,"'MPH'",1) ;
		    {
		    if(nFBS)
			 {
			 nWindSpeed = atoi(left_string(sRSS.windspeed,nFBS - 2)) ;
			 }
		    else
			 {
			 nWindSpeed = 0 ;
			 }
		    }
	       i ++ ;
	       }
	  else
	       {
	       sRSS.windspeed = 'N/A' ;
	       nWindSpeed = 0 ;
	       }
	  nFBS = find_string(iRSSBuf,'<dt',1) ;
	  if(nFBS > 1)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf,nFBS -1) ;
	       }
	  if(find_string(iRSSBuf,'">Wind Direction:</dt>',1) && find_string(iRSSBuf,'</dd>',1))
	       {
	       STACK_VAR CHAR cRSS_StrTmp[255] ;
	          
	       //cRSSTrash = remove_string(iRSSBuf,'">Wind Direction:</dt>',1) ;
	       cRSS_StrTmp = remove_string(iRSSBuf,'</dd>',1) ;
	       cRSSTrash = remove_string(cRSS_StrTmp,'inline;">',1) ;
	       nFBS = find_string(cRSS_StrTmp,'(',1)
	       if(nFBS)
		    {
		    sRSS.winddir = get_buffer_string(cRSS_StrTmp,nFBS - 1)
		    cRSSTrash = remove_string(cRSS_StrTmp,'(',1)
		    nFBS = find_string(cRSS_StrTmp,'&#176',1)
		    sRSS.winddir = "sRSS.winddir,get_buffer_string(cRSS_StrTmp,nFBS - 1)"
		    }
	       else
		    {
		    nFBS = find_string(cRSS_StrTmp,'</dd>',1) ;
		    sRSS.winddir = get_buffer_string(cRSS_StrTmp,nFBS - 1) ;
		    if(find_string(sRSS.winddir,'VRB',1))
			 {
			 sRSS.winddir = 'Variable' ;
			 }
		    }
	       i ++ ;
	       }
	  else
	       {
	       sRSS.winddir = 'N/A' ;
	       }
	  nFBS = find_string(iRSSBuf,'<dt',1) ;
	  if(nFBS > 1)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf,nFBS -1) ;
	       }
	  if(find_string(iRSSBuf,'">Gusts:</dt>',1) && find_string(iRSSBuf,'</dd>',1))
	       {
	       STACK_VAR CHAR cRSS_StrTmp[255] ;
	       
	       //cRSSTrash = remove_string(iRSSBuf,'">Gusts:</dt>',1) ;
	       cRSS_StrTmp = remove_string(iRSSBuf,'</dd>',1) ;
	       cRSSTrash = remove_string(cRSS_StrTmp,'inline;">',1) ;
	       nFBS = find_string(cRSS_StrTmp,'</dd>',1) ;
	       sRSS.gusts = get_buffer_string(cRSS_StrTmp,nFBS - 1) ;
	       nFBS = find_string(sRSS.gusts,"'MPH'",1) ;
		    {
		    if(nFBS)
			 {
			 nWindGusts = atoi(left_string(sRSS.gusts,nFBS - 2)) ;
			 }
		    else
			 {
			 nWindGusts = 0 ;
			 }
		    }
	       i ++
	       }
	  else
	       {
	       sRSS.gusts = 'N/A'
	       }     
	  nFBS = find_string(iRSSBuf,'<dt',1) ;
	  if(nFBS > 1)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf,nFBS -1) ;
	       }
	  if(find_string(iRSSBuf,'">Barometer:</dt>',1) && find_string(iRSSBuf,'</dd>',1))
	       {
	       STACK_VAR CHAR cRSS_StrTmp[255] ;
	       
	       //cRSSTrash = remove_string(iRSSBuf,'">Barometer:</dt>',1) ;
	       cRSS_StrTmp = remove_string(iRSSBuf,'</dd>',1) ;
	       cRSSTrash = remove_string(cRSS_StrTmp,'inline;">',1) ;
	       nFBS = find_string(cRSS_StrTmp,'</dd>',1) ;
	       sRSS.pressure = get_buffer_string(cRSS_StrTmp, nFBS - 1) ;
	       i ++
	       }
	  else
	       {
	       sRSS.pressure = 'N/A' ;
	       }         
	  nFBS = find_string(iRSSBuf,'<dt',1) ;
	  if(nFBS > 1)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf,nFBS -1) ;
	       }
	  if(find_string(iRSSBuf,'">Dewpoint:</dt>',1) && find_string(iRSSBuf,'</dd>',1))
	       {
	       STACK_VAR CHAR cRSS_StrTmp[255] ;
	       
	       //cRSSTrash = remove_string(iRSSBuf,'">Dewpoint:</dt>',1) ;
	       cRSS_StrTmp = remove_string(iRSSBuf,'</dd>',1) ;
	       cRSSTrash = remove_string(cRSS_StrTmp,'inline;">',1) ;
	       nFBS = find_string(cRSS_StrTmp,'&#176;F',1) ;
	       if(nFBS)
		    {
		    sRSS.dewpoint = "get_buffer_string(cRSS_StrTmp,nFBS - 1),'F'" ;
		    }
	       else
		    {
		    nFBS = find_string(cRSS_StrTmp,'</dd>',1) ;
		    if(nFBS)
			 {
			 sRSS.dewpoint = "get_buffer_string(cRSS_StrTmp,nFBS - 1),'F'" ;
			 }
		    }
	       i ++ ;
	       }
	  else
	       {
	       sRSS.dewpoint = 'N/A' ;
	       } 
	  nFBS = find_string(iRSSBuf,'<dt',1) ;
	  if(nFBS > 1)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf,nFBS -1) ;
	       }
	  if(find_string(iRSSBuf,'">Heat Index:</dt>',1) && find_string(iRSSBuf,'</dd>',1))
	       {
	       STACK_VAR CHAR cRSS_StrTmp[255] ;
	       
	       //cRSSTrash = remove_string(iRSSBuf,'">Heat Index:</dt>',1) ;
	       cRSS_StrTmp = remove_string(iRSSBuf,'</dd>',1) ;
	       cRSSTrash = remove_string(cRSS_StrTmp,'inline;">',1) ;
	       nFBS = find_string(cRSS_StrTmp,'&#176;F',1) ;
	       if(nFBS)
		    {
		    sRSS.heatindex = "get_buffer_string(cRSS_StrTmp,nFBS - 1),'F'" ;
		    }
	       else
		    {
		    nFBS = find_string(cRSS_StrTmp,'</dd>',1) ;
		    if(nFBS)
			 {
			 sRSS.heatindex = "get_buffer_string(cRSS_StrTmp,nFBS - 1),'F'" ;
			 }
		    }
	       i ++ ;
	       }
	  else
	       {
	       sRSS.heatindex = 'N/A' ;
	       }   
	  nFBS = find_string(iRSSBuf,'<dt',1) ;
	  if(nFBS > 1)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf,nFBS -1) ;
	       }
	  if(find_string(iRSSBuf,'">Wind Chill:</dt>',1) && find_string(iRSSBuf,'</dd>',1))
	       {
	       STACK_VAR CHAR cRSS_StrTmp[255] ;
	       
	       //cRSSTrash = remove_string(iRSSBuf,'">Wind Chill:</dt>',1) ;
	       cRSS_StrTmp = remove_string(iRSSBuf,'</dd>',1) ;
	       cRSSTrash = remove_string(cRSS_StrTmp,'inline;">',1) ;
	       nFBS = find_string(cRSS_StrTmp,'&#176;F',1) ;
	       if(nFBS)
		    {
		    sRSS.windchill = "get_buffer_string(cRSS_StrTmp, nFBS - 1),'F'" ;
		    }
	       else
		    {
		    nFBS = find_string(cRSS_StrTmp,'</dd>',1) ;
		    if(nFBS)
			 {
			 sRSS.windchill = "get_buffer_string(cRSS_StrTmp, nFBS - 1),'F'" ;
			 }
		    }
	       i ++ ;
	       }
	  else
	       {
	       sRSS.windchill = 'N/A' ;
	       }
	  nFBS = find_string(iRSSBuf,'<dt',1) ;
	  if(nFBS > 1)
	       {
	       cRSSTrash = get_buffer_string(iRSSBuf,nFBS -1) ;
	       }
	  if(find_string(iRSSBuf,'">Visibility:</dt>',1) && find_string(iRSSBuf,'</dd>',1))
	       {
	       STACK_VAR CHAR cRSS_StrTmp[255] ;
	       
	       //cRSSTrash = remove_string(iRSSBuf,'">Visibility:</dt>',1) ;
	       cRSS_StrTmp = remove_string(iRSSBuf,'</dd>',1) ;
	       cRSSTrash = remove_string(cRSS_StrTmp,'inline;">',1) ;
	       nFBS = find_string(cRSS_StrTmp,'</dd>',1) ;
	       sRSS.visibility = get_buffer_string(cRSS_StrTmp, nFBS - 1) ;
	       i ++ ;
	       }
	  else
	       {
	       sRSS.visibility = 'N/A' ;
	       }
	  for (n = 1; n <= 5; n++)
	       {
	       nFBS = find_string(iRSSBuf,'<title>Forecast',1) ;
	       if (nFBS)
		    {
		    cRSSTrash = get_buffer_string(iRSSBuf, nFBS + 6) ;
		    nFBS = find_string(iRSSBuf,'</title>',1) ;
		    sForecasts[n].title = get_buffer_string(iRSSBuf,nFBS - 1) ;
		    cRSSTrash = remove_string(iRSSBuf,'<description>',1) ;
		    nFBS = find_string(iRSSBuf,'</description>',1) ;
		    sForecasts[n].description = fnReplace(get_buffer_string(iRSSBuf,nFBS - 1), "STR_LF", "32") ;
		    i ++ ;
		    }
	       else
		    {
		    sForecasts[n].description = 'N/A' ;
		    }
	       }
	  }
     else
	  {
	  fnWx_DeBug("'RSS - Did not return correct City information! :DEBUG<',ITOA(__LINE__),'>'") ;
	       //   Comment the out or remove the following finction line if you prefer to display
	       //   "last valid" data when the city info is not good
	  fnErrorDisplay () ;
	  }
     clear_buffer iRSSBuf ;
     
     fnWx_DeBug("'RSS - PARSING COMPLETE! - Received & parsed ',itoa(i),' of a possible 20 values! :DEBUG<',ITOA(__LINE__),'>'") ;
     
     if(i < 18)
     	  {
	  fnSendSitrep(i,TRUE) ;
	  }
     else 
	  {
	  if(nWx_DeBug || !nRunOne)
	       {
	       fnSendSitrep(i,FALSE) ;
	       nRunOne = 1 ;
	       }
	  }
     fnVAV_MyWeatherFB(UI_UPDATE_ACTIVE) ;
     RETURN TRUE ;
     }
     
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)

///// THIS COMPARISON TO SECOND "SENT" STRUCTURE ISN'T  REALLY NECESSARY.  
///// YOU CAN REMOVE THE IF'S AND SENT STRUCTURE IF YOU WANT!!

DEFINE_FUNCTION fnFB_DoSend_VT(INTEGER iUI_Indx,INTEGER iCHAN,CHAR iStrMSG[]) 
     
     {
     STACK_VAR INTEGER n ;
     STACK_VAR INTEGER nUICount ; 
     STACK_VAR INTEGER nLoopStart ; 
     
     if(iUI_Indx)
	  {
	  nUICount = iUI_Indx ;
	  nLoopStart = iUI_Indx ;
	  }
     else
	  {
	  nUICount = length_array(dvUI_Arry) ;
	  nLoopStart = 1 ;
	  }
	  
     ////fnDevMod_DeBug("'SEND_VT: ',iStrMSG,' :DEBUG <',itoa(__LINE__),'>'") ;
     
     for(n = nLoopStart ; n <= nUICount ; n++)
	  {
	  if(nUI_WXActiveArry[n] || nUI_TypeArry[n] != UI_TYPE_R4)//   always refresh main page display items  
	       {
	       SWITCH(nUI_TypeArry[n])
		    {
		    CASE UI_TYPE_G4:
		    CASE UI_TYPE_R4:
		    CASE UI_TYPE_MIO_DMS:
			(* {
			 STACK_VAR WIDECHAR cSTRING1[500] ;
			 STACK_VAR CHAR cSTRING2[500] ;
			 
			 cSTRING1 = WC_DECODE(iStrMSG,WC_FORMAT_UTF8,1) ; 
			 cSTRING2 = WC_ENCODE(cSTRING1,WC_FORMAT_TP,1) ;
			 //////fnDevMod_DeBug("'^UNI- TP INDX: ',itoa(n),', CHNL: ',itoa(iCHAN),' :DEBUG <',ITOA(__LINE__),'>'") ;
			 SEND_COMMAND dvUIArry[n], "'^UNI-',itoa(iCHAN),',0,',cSTRING2" ; 
			 }
			 *)
		    CASE UI_TYPE_G3:
		    CASE UI_TYPE_iPHONE:
		    CASE UI_TYPE_iTOUCH:
		    CASE UI_TYPE_iPAD:
			 {//SEND_COMMAND <DEV>,"'^TXT-<vt addr range>,<button states range>,<new text>'"
			 //////fnDevMod_DeBug("'^TXT- TP INDX: ',itoa(n),', CHNL: ',itoa(iCHAN),' :DEBUG <',ITOA(__LINE__),'>'") ;
			 SEND_COMMAND dvUI_Arry[n], "'^TXT-',itoa(iCHAN),',0,',iStrMSG" ; 
			 }
		    CASE UI_TYPE_METKP:
		    CASE UI_TYPE_UNKNOWN:
		    CASE UI_TYPE_VIRTUAL:
			 {
			 //DO NOTHING
			 }
		    }
	       }
	  }
	  
     RETURN ;
     }
     
DEFINE_FUNCTION fnFB_DoSend_UI_CMD(INTEGER iUI_Indx,CHAR strMSG[]) 

     {
     STACK_VAR INTEGER n ;
     STACK_VAR INTEGER nUICount ; 
     STACK_VAR INTEGER nLoopStart ; 
     
     if(iUI_Indx)
	  {
	  nUICount = iUI_Indx ;
	  nLoopStart = iUI_Indx ;
	  }
     else
	  {
	  nUICount = length_array(dvUI_Arry) ;
	  nLoopStart = 1 ;
	  }
	  
     ////fnDevMod_DeBug("'fnFB_DoSend_UI_CMD: Running FB! :DEBUG <',ITOA(__LINE__),'>'") ;
     
     for(n = nLoopStart ; n <= nUICount ; n++)
          {
	  if(TRUE)//always update mian page display items 
	       {
	       SWITCH(nUI_TypeArry[n])
		    {
		    CASE UI_TYPE_G4:
		    CASE UI_TYPE_G3:
		    CASE UI_TYPE_R4:
		    CASE UI_TYPE_iPHONE:
		    CASE UI_TYPE_iTOUCH:
		    CASE UI_TYPE_iPAD:
			 {
			 //fnDevMod_DeBug("'fnFB_DoSend_UI_CMD: UI=',fnDEV_TO_STRING(dvUIArry[n]),', Cmd=',strMSG,'. :DEBUG <',ITOA(__LINE__),'>'") ;
			 SEND_COMMAND dvUI_Arry[n],strMSG ; 
			 }
		    CASE UI_TYPE_MIO_DMS:
		    CASE UI_TYPE_METKP:
		    CASE UI_TYPE_UNKNOWN:
		    CASE UI_TYPE_VIRTUAL:
			 {
			 //DO NOTHING
			 }
		    }
	       }
	  }
  
     RETURN ;
     }

DEFINE_FUNCTION CHAR fnVAV_MyWeatherFB(INTEGER iUI_Indx)
     {  
     if (sRSSsent.lastupdate != sRSS.lastupdate)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_lastupdate],sRSS.lastupdate) ;
	  sRSSsent.lastupdate = sRSS.lastupdate
	  }
     if (sRSSsent.title != sRSS.title)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_title],sRSS.title) ;
	  //fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_title],'Wesport, Connecticut Weather') ;
	  sRSSsent.title = sRSS.title
	  }
     if (sRSSsent.rcvdzip != sRSS.rcvdzip)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_rcvdzip],sRSS.rcvdzip) ;
	  sRSSsent.rcvdzip = sRSS.rcvdzip
	  }
     if (sRSSsent.overview != sRSS.overview)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_overview],sRSS.overview) ;
	  sRSSsent.overview = sRSS.overview
	  }
     if (sRSSsent.description != sRSS.description)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_description],sRSS.description) ;
	  sRSSsent.description = sRSS.description
	  }
     if (sRSSsent.icon != sRSS.icon)                             
	  {
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BMP-',itoa(nFeedback[WeatherIcon_Btn]),',0,wicon_',sRSS.icon,'.png'") ;
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_icon],sRSS.icon) ;
	  sRSSsent.icon = sRSS.icon
	  }     
     if (sRSSsent.pubdate != sRSS.pubdate)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_pubdate],sRSS.pubdate) ;
	  sRSSsent.pubdate = sRSS.pubdate
	  }
     if (sRSSsent.humidity != sRSS.humidity)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_humidity],sRSS.humidity) ;
	  sRSSsent.humidity = sRSS.humidity
	  }
     if (sRSSsent.windspeed != sRSS.windspeed)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_windspeed],sRSS.windspeed) ;
	  sRSSsent.windspeed = sRSS.windspeed
	  }
     if (sRSSsent.winddir != sRSS.winddir)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_winddir],sRSS.winddir) ;
	  sRSSsent.winddir = sRSS.winddir
	  }
     if (sRSSsent.gusts != sRSS.gusts)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_gusts],sRSS.gusts) ;
	  sRSSsent.gusts = sRSS.gusts
	  }
     if (sRSSsent.pressure != sRSS.pressure)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_pressure],sRSS.pressure) ;
	  sRSSsent.pressure = sRSS.pressure
	  }
     if (sRSSsent.dewpoint != sRSS.dewpoint)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_dewpoint],sRSS.dewpoint) ;
	  sRSSsent.dewpoint = sRSS.dewpoint
	  }
     if (sRSSsent.heatindex != sRSS.heatindex)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_heatindex],sRSS.heatindex) ;
	  sRSSsent.heatindex = sRSS.heatindex
	  }
     if (sRSSsent.windchill != sRSS.windchill)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_windchill],sRSS.windchill) ;
	  sRSSsent.windchill = sRSS.windchill
	  }
     if (sRSSsent.visibility != sRSS.visibility)                             
	  {               
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_visibility],sRSS.visibility) ;
	  sRSSsent.visibility = sRSS.visibility
	  }
     if (sForecastsSent[1].title != sForecasts[1].title)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_fcastTitle_1],sForecasts[1].title) ;
	  sForecastsSent[1].title = sForecasts[1].title
	  }
     if (sForecastsSent[1].description != sForecasts[1].description)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_forecast_1],LEFT_STRING(sForecasts[1].description,100)) ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_1]),',0,',MID_STRING(sForecasts[1].description,101,100)") ;  
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_1]),',0,',MID_STRING(sForecasts[1].description,201,100)") ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_1]),',0,',MID_STRING(sForecasts[1].description,301,100)") ; 
	  sForecastsSent[1].description = sForecasts[1].description
	  }
     if (sForecastsSent[2].title != sForecasts[2].title)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_fcastTitle_2],sForecasts[2].title) ;
	  sForecastsSent[2].title = sForecasts[2].title
	  }
     if (sForecastsSent[2].description != sForecasts[2].description)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_forecast_2],LEFT_STRING(sForecasts[2].description,100)) ;
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_2]),',0,',MID_STRING(sForecasts[2].description,101,100)") ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_2]),',0,',MID_STRING(sForecasts[2].description,201,100)") ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_2]),',0,',MID_STRING(sForecasts[2].description,301,100)") ; 
	  sForecastsSent[2].description = sForecasts[2].description
	  }
     if (sForecastsSent[3].title != sForecasts[3].title)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_fcastTitle_3],sForecasts[3].title) ;
	  sForecastsSent[3].title = sForecasts[3].title
	  }
     if (sForecastsSent[3].description != sForecasts[3].description)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_forecast_3],LEFT_STRING(sForecasts[3].description,100)) ;
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_3]),',0,',MID_STRING(sForecasts[3].description,101,100)") ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_3]),',0,',MID_STRING(sForecasts[3].description,201,100)") ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_3]),',0,',MID_STRING(sForecasts[3].description,301,100)") ; 
	  sForecastsSent[3].description = sForecasts[3].description
	  }
     if (sForecastsSent[4].title != sForecasts[4].title)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_fcastTitle_4],sForecasts[4].title) ;
	  sForecastsSent[4].title = sForecasts[4].title
	  }
     if (sForecastsSent[4].description != sForecasts[4].description)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_forecast_4],LEFT_STRING(sForecasts[4].description,100)) ;
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_4]),',0,',MID_STRING(sForecasts[4].description,101,100)") ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_4]),',0,',MID_STRING(sForecasts[4].description,201,100)") ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_4]),',0,',MID_STRING(sForecasts[4].description,301,100)") ; 
	  sForecastsSent[4].description = sForecasts[4].description
	  }
     if (sForecastsSent[5].title != sForecasts[5].title)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_fcastTitle_5],sForecasts[5].title) ;
	  sForecastsSent[5].title = sForecasts[5].title
	  }
     if (sForecastsSent[5].description != sForecasts[5].description)
	  {
	  fnFB_DoSend_VT(iUI_Indx,nFeedback[VT_forecast_5],LEFT_STRING(sForecasts[5].description,100)) ;
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_5]),',0,',MID_STRING(sForecasts[5].description,101,100)") ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_5]),',0,',MID_STRING(sForecasts[5].description,201,100)") ; 
	  fnFB_DoSend_UI_CMD(iUI_Indx,"'^BAT-',ITOA(nFeedback[VT_forecast_5]),',0,',MID_STRING(sForecasts[5].description,301,100)") ; 
	  sForecastsSent[5].description = sForecasts[5].description
	  }
     RETURN TRUE ;
     }

DEFINE_FUNCTION CHAR fnConnectRSS(CHAR iFromWhere [])

     {
     //fnWx_DeBug(""'Time ',Time,' - Updating RSS Weather! From: *-',iFromWhere,'-* :DEBUG<',ITOA(__LINE__),'>'") ;

     ip_client_open (dvRSS.Port,'www.rssweather.com',80,1) ;//ok for rss/xml and html //
     
     RETURN TRUE ;
     }
     
DEFINE_FUNCTION CHAR fnGetRSS()

     {
     //fnWx_DeBug("'RSS Connected! :DEBUG<',ITOA(__LINE__),'>'") ;
     //fnWx_DeBug("'RSS Sent: "GET /wx/',lower_string(sCity.country),'/',lower_string(sCity.state),'/',lower_string(sCity.city),'/rss.php"',STR_CRLF")
     //http://www.rssweather.com/wx/us/ma/springfield/rss.php
     SEND_STRING dvRSS,"'GET /wx/',lower_string(sCity.country),'/',
					lower_string(sCity.state),'/',
					     lower_string(sCity.city),'/rss.php',STR_CRLF"
    
    //SEND_STRING dvRSS,"'GET /rss.php?hwvUT=F&hwvUP=in&hwvUS=mph&hwvUV=mi&hwvCCChange=time&hwvSF=Y',
//				   '&maxdays=5&daysonly=0&hwvStyle=body&place=',lower_string(sCity.city),
//				   '&state=',lower_string(sCity.state),'&zipcode=',sCity.zip,
//				   '&country=',lower_string(sCity.country),'&county=',lower_string(sCity.county),
//				   '&zone=',upper_string(sCity.zone),'&alt=rss20a HTTP/1.1',STR_CRLF" ;
     ///////////////////////////////////////////////////////////////////////////////////////////
     ///////////////////////////////////////////////////////////////////////////////////////////
     /////////      HTML WEATHER FEED                                                ///////////
     /////////      NEED NEW PASRER FOR HTML TO USE                                  ///////////
     ///////// SEND_STRING dvRSS," 'GET /zipcode/06853/wx.php',STR_CRLF"  //ok for html  ///////////
     ///////////////////////////////////////////////////////////////////////////////////////////
     ///////////////////////////////////////////////////////////////////////////////////////////
     SEND_STRING dvRSS,"'Host: www.rssweather.com',STR_CRLF" ; // ok for rss/xml and html
     SEND_STRING dvRSS,"STR_CRLF" ;
     //fnWx_DeBug("'RSS Get Request Sent! :DEBUG<',ITOA(__LINE__),'>'") ;
   
	  
     RETURN TRUE ;
     }
     
DEFINE_FUNCTION CHAR fnClearStored ()          
     {
     STACK_VAR CHAR nCount ;
     
     sRSSsent.lastupdate = "'refresh'" ;
     sRSSsent.title = "'refresh'" ;
     sRSSsent.rcvdzip = "'refresh'" ;
     sRSSsent.overview = "'refresh'" ;
     sRSSsent.description = "'refresh'" ;
     sRSSsent.icon = "'refresh'" ;
     sRSSsent.pubdate = "'refresh'" ;
     sRSSsent.humidity = "'refresh'" ;
     sRSSsent.windspeed = "'refresh'" ;
     sRSSsent.winddir = "'refresh'" ;
     sRSSsent.gusts = "'refresh'" ;
     sRSSsent.pressure = "'refresh'" ;
     sRSSsent.dewpoint = "'refresh'" ;
     sRSSsent.heatindex = "'refresh'" ;
     sRSSsent.windchill = "'refresh'" ;
     sRSSsent.visibility = "'refresh'" ;
     
     FOR (nCount = 1; nCount <= 5; nCount ++)
	  {
	  sForecastsSent[nCount].description = "'refresh'" ;
	  sForecastsSent[nCount].title = "'refresh'" ;
	  }
	  
     RETURN TRUE ;
     }

DEFINE_FUNCTION CHAR fnErrorDisplay()          
     {
     STACK_VAR CHAR nCount ;
    
     sRSS.lastupdate = "'N/A'" ;
     sRSS.title = "'Invalid City Data'" ;
     sRSS.rcvdzip = "'N/A'" ;
     sRSS.overview = "'N/A'" ;
     sRSS.description = "'N/A'" ;
     sRSS.icon = "'na'" ;
     sRSS.pubdate = "'N/A'" ;
     sRSS.humidity = "'N/A'" ;
     sRSS.windspeed = "'N/A'" ;
     sRSS.winddir = "'N/A'" ;
     sRSS.gusts = "'N/A'" ;
     sRSS.pressure = "'N/A'" ;
     sRSS.dewpoint = "'N/A'" ;
     sRSS.heatindex = "'N/A'" ;
     sRSS.windchill = "'N/A'" ;
     sRSS.visibility = "'N/A'" ;
	               
     FOR (nCount = 1; nCount <= 5; nCount ++)
	  {
	  sForecasts[nCount].description = "'N/A'" ;
	  sForecasts[nCount].title = "''" ;
	  }
     fnVAV_MyWeatherFB(UI_UPDATE_ACTIVE) ;
     
     RETURN TRUE ;
     }
     
DEFINE_FUNCTION CHAR fnFileWrite_ToFile(CHAR iWriteFileName[],CHAR iWriteFileBuf[])
     {                                       //filename   //buffer containing data to write
     stack_var slong nWriteFHandle ;
     stack_var slong nWriteFResult ;
     stack_var slong nCloseResult ;
     
     nWriteFHandle = file_open(iWriteFileName,FILE_RW_NEW) ;
     if(nWriteFHandle > 0) 
	  {
	  //fnWx_DeBug("'FUNCTION fnFileWrite_ToFile. File_Open successful for *',iWriteFileName,'*! :DEBUG<',ITOA(__LINE__),'>'") ;
	 
	  nWriteFResult = FILE_WRITE (nWriteFHandle,iWriteFileBuf,length_string(iWriteFileBuf)) ;
	  nCloseResult = file_close(nWriteFHandle) ;
	  if(nWriteFResult > 0) 
	       {
	       //fnWx_DeBug("'FUNCTION fnFileWrite_ToFile. File_Write OK. Wrote a ',itoa(nWriteFResult),' CHAR String!  :DEBUG<',ITOA(__LINE__),'>'") ; 
	       //fnWx_DeBug("'FUNCTION fnFileWrite_ToFile. File Closed. Close Result ',itoa(nCloseResult),':DEBUG<',ITOA(__LINE__),'>'") ; 
		
		    
	       RETURN TRUE ;
	       }
	  else
	       {
	       stack_var char cErrorMsg [60] ;
	       
	       switch(itoa(nWriteFResult)) 
		    {
		    case '-11': {cErrorMsg = 'disk full'} ;
		    case '-5' : {cErrorMsg = 'disk I/O error'} ;
		    case '-1' : {cErrorMsg = 'invalid file handle'} ;
		    case '-6' : {cErrorMsg = 'invalid parameter (buffer length must be greater than zero)'} ;
		    }
	       //fnWx_DeBug("'FUNCTION fnFileWrite_ToFile. Bad File_Write_Line: ',cErrorMsg,'! :DEBUG<',ITOA(__LINE__),'>'") ;
	       //fnWx_DeBug("'FUNCTION fnFileWrite_ToFile. File Closed. Close Result ',itoa(nCloseResult),':DEBUG<',ITOA(__LINE__),'>'") ; 
		
		    
	       RETURN FALSE ;
	       }
	  }
     else
	  {
	  stack_var char cErrorMsg [40] ;
	  
	  nCloseResult = file_close(nWriteFHandle) ;
	  switch (itoa(nWriteFHandle)) 
	       {
	       case '-2': {cErrorMsg = 'invalid file path or name'} ;
	       case '-5': {cErrorMsg = 'disk I/O error'} ;
	       case '-3': {cErrorMsg = 'invalid value supplied for IOFlag'} ;
	       }
	  //fnWx_DeBug("'FUNCTION fnFileWrite_ToFile. Bad File_Open: ',cErrorMsg,'! :DEBUG<',ITOA(__LINE__),'>'") ;
	  //fnWx_DeBug("'FUNCTION fnFileWrite_ToFile. File Closed. Close Result ',itoa(nCloseResult),':DEBUG<',ITOA(__LINE__),'>'") ; 
	   
	       
	  RETURN FALSE ; 
	  }
     }  

DEFINE_FUNCTION INTEGER fnFileRead(CHAR iReadFileName[], CHAR iReadFileBuf[])
     {
     stack_var slong nReadFHandle ;
     stack_var slong nReadFResult ;
     
     nReadFHandle = file_open(iReadFileName,FILE_READ_ONLY) ;
     if (nReadFHandle > 0) 
	  {
	  //fnWx_DeBug("'FUNCTION fnReadFile. File_Open successful for *',iReadFileName,'*! :DEBUG<',ITOA(__LINE__),'>'") ;
	 
	  nReadFResult = file_read(nReadFHandle,iReadFileBuf,LICENSE_READ_BUFLENGTH) ;
	  if (nReadFResult > 0) 
	       {
	       //fnWx_DeBug("'FUNCTION fnReadFile. File_Read OK. Rcvd: a ',itoa(length_string(iReadFileBuf)),' CHAR String!  :DEBUG<',ITOA(__LINE__),'>'") ; 
		
	       }
	  else
	       {
	       stack_var char cErrorMsg [20] ;
	       switch (itoa(nReadFResult)) 
		    {
		    case '-9': {cErrorMsg = 'end-of-file reached'} ;
		    case '-6': {cErrorMsg = 'invalid parameter'} ;
		    case '-5': {cErrorMsg = 'disk I/O error'} ;
		    case '-1': {cErrorMsg = 'invalid file handle'} ;
		    case '-0': {cErrorMsg = 'zero bits returned?'} ;
		    }
	       //fnWx_DeBug("'FUNCTION fnReadFile. Bad Read_File: ',cErrorMsg,'! :DEBUG<',ITOA(__LINE__),'>'") ;
		
	       file_close(nReadFHandle) ;
	       
	       RETURN FALSE ;
	       }
	  }
     else
	  {
	  stack_var char cErrorMsg [40] ;
	  switch (itoa(nReadFHandle)) 
	       {
	       case '-2': {cErrorMsg = 'invalid file path or name'} ;
	       case '-5': {cErrorMsg = 'disk I/O error'} ;
	       case '-3': {cErrorMsg = 'invalid value supplied for IOFlag'} ;
	       }
	  //fnWx_DeBug("'FUNCTION fnReadFile. Bad Open_File: ',cErrorMsg,'! :DEBUG<',ITOA(__LINE__),'>'") ;
	 
	  file_close(nReadFHandle) ;
	  
	  RETURN FALSE ;
	  }
     file_close(nReadFHandle) ;
     
     RETURN TRUE ;
     } 

DEFINE_FUNCTION CHAR fnWeather_LoadStoredValues(CHAR iReadFileName[], CHAR iReadFileBuf[], CHAR iStructure[]) 

     {
     stack_var slong nWEATHER_READ_OK ;
     
     nWEATHER_READ_OK = fnFileRead(iReadFileName,iReadFileBuf) ;
     if (nWEATHER_READ_OK)
	  {
	  stack_var sinteger nXML_Decode_Return ;
	  stack_var char cXML_MSG[100] ;
	  stack_var long nPOS ;
	  
	  //fnWx_DeBug("'Weather_Module: Loading RAM FILES: Line-<',ITOA(__LINE__),'>'") ;
	  
	  nPOS = 1 ;
	  Switch(iStructure)
	       {
	       CASE 'KEY':
		    {
		    nXML_Decode_Return = XML_TO_VARIABLE (sLicenseKey,iReadFileBuf,nPOS,0) ;
		    }
	       CASE 'DATA':
		    {
		    nXML_Decode_Return = XML_TO_VARIABLE (sLicenseData,iReadFileBuf,nPOS,0) ;
		    }
	       }
	  if(nWx_DeBug)
	       {
	       switch (itoa(nXML_Decode_Return))
		    {
		    case '-1': {cXML_MSG = 'ERROR -1 = decode variable type mismatch' } ;
		    case '-2': {cXML_MSG = 'ERROR -2 = decode data too small, decoder ran out of data. Most likely poorly formed XML.' } ;
		    case '-3': {cXML_MSG = 'ERROR -3 = output character buffer was too small' } ;
		    case '3' : {cXML_MSG = 'ERROR  3 = XML decode data type mismatch' } ;
		    case '2' : {cXML_MSG = 'ERROR  2 = XML decode data too small, more members in structure' } ;
		    case '1' : {cXML_MSG = 'ERROR  1 = structure too small, more members in XML decode string' } ;
		    case '0' : {cXML_MSG = 'Returned 0 = decoded OK! ' } ;
		    }
	       fnWx_DeBug("'Weather_Module: XML Loading: ',cXML_MSG,' :DEBUG<',ITOA(__LINE__),'>'") ;
	       }
	  }
     else
	  {
	  RETURN FALSE ;
	  }
     clear_buffer iReadFileBuf ;
     
     RETURN TRUE ;
     }     

DEFINE_START

create_buffer dvRSS, cRSSBuf ; 
 


sCity.country = sCityData[1] 
sCity.county  = sCityData[2] 
sCity.state   = sCityData[3] 
sCity.zone    = sCityData[4] 
sCity.city    = sCityData[5] 
sCity.zip     = sCityData[6] 

/////////////////////////////////////////////////////////////
/////////////    EVALUTE REFRESH_TIME    ////////////////////
/////////////////////////////////////////////////////////////

if (nRefreshTime > 60)
     {
     nWDataRefresh[1] = (nRefreshTime * 60000) ;
     }
else 
     {
     nWDataRefresh[1] = (REFRESH_TIME * 60000) ;
     }
     
////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////

wait 450
     {
     if(!TIMELINE_ACTIVE(TL_RefreshWeatherFB))
	  {
	  TIMELINE_CREATE(TL_RefreshWeatherFB, nWDataRefresh, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT) 
	  }
     }

wait 7500 'RSS_STARTUP_CONNECT'  
     {
     fnConnectRSS('Define_Start') ;
     TIMELINE_RELOAD(TL_RefreshWeatherFB, nWDataRefresh, 1) ;  
     }

//nGotDMS_KPs = fnFindDMS_KPs() ;

(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)

DEFINE_EVENT    //BUTTON_EVENT [dvUI_Arry,nBtnArry]

BUTTON_EVENT [dvUI_Arry,0] //nBtnArry]
     {
     PUSH:
	  {
	  stack_var integer nRssBtn ;
	  stack_var integer nUI_Indx ;
	  
	  nRssBtn = BUTTON.INPUT.CHANNEL ;// get_last(nBtnArry)
	  nUI_Indx = GET_LAST(dvUI_Arry) ;
	  
	  Switch (nRssBtn)////add button functions as needed
	       {
	       case 1:
		    {
		    // REFRESH / UPDATE
		    fnClearStored() ;
		    CANCEL_WAIT 'RSS_STARTUP_CONNECT' ;
		    fnConnectRSS('Button_Event') ;
		    break ;
		    }
	       case 2:
		    {
                    //add button functions as needed
		    break ;
		    }
	       case 200:
		    {
		    nUI_WXActiveArry[nUI_Indx] = 0 ;
		    }
	       case 201:
		    {
		    nUI_WXActiveArry[nUI_Indx] = 1 ;
		    fnVAV_MyWeatherFB(nUI_Indx) ;
		    }
	       }
	  }
     }
     
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)
(*VAVAVAVAVVAVAVAVAAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVAVVAVVAV*)

DEFINE_EVENT    //DATA_EVENT [dvRSS]

DATA_EVENT [dvRSS]
     {
     ONLINE:
	  {
	  fnGetRSS()
	  }
     STRING:
	  {
	  if (find_string(cRSSBuf,'</rss>',1))
	       {
	       //fnWx_DeBug("'RSS captured:',itoa(length_string(cRSSBuf)),' bytes from server! :DEBUG<',ITOA(__LINE__),'>'") ;
		//fnWx_DeBug("'RSS captured data sent to parser! :DEBUG<',ITOA(__LINE__),'>'") ;
		
	       clear_buffer cRSSBuf_Notify ;
	       cRSSBuf = REMOVE_STRING(cRSSBuf,'</rss>',1) ;
	       cRSSBuf_Notify = cRSSBuf ;
	       fnRSSParser(cRSSBuf) ;
	       clear_buffer cRSSBuf ;
	       }
	  }
     OFFLINE:
	  {
	  //fnWx_DeBug("'RSS server disconnected! :DEBUG<',ITOA(__LINE__),'>'") ;
	   
	  }
     ONERROR:
	  {
	  //fnWx_DeBug("'RSS status code: ',ITOA(DATA.NUMBER),' :DEBUG<',ITOA(__LINE__),'>'") ;
		  }
     }

DEFINE_EVENT    //TIMELINE_EVENT [TL_RefreshWeatherFB]

TIMELINE_EVENT [TL_RefreshWeatherFB]

     {
     fnConnectRSS('TimeLine_Event') ;
     }
     
DEFINE_PROGRAM

WAIT 50
     {
     if((sCityData[1] <> sCity.country) || (sCityData[2] <> sCity.county) || (sCityData[3] <> sCity.state) ||
	 (sCityData[4] <> sCity.zone)    || (sCityData[5] <> sCity.city)   || (sCityData[6] <> sCity.zip))
	  {
	  sCity.country = sCityData[1] ;
	  sCity.county  = sCityData[2] ;
	  sCity.state   = sCityData[3] ;
	  sCity.zone    = sCityData[4] ;
	  sCity.city    = sCityData[5] ;
	  sCity.zip     = sCityData[6] ;
	  fnClearStored () ;
	  fnConnectRSS('Define_Program') ;
	  }
     if(nTest_Wx_SitRep)
	  {
	  SWITCH(nTest_Wx_SitRep)
	       {
	       CASE 1:{fnSendSitrep(20,FALSE)}
	       CASE 2:{fnSendSitrep(10,FALSE)}
	       CASE 3:{fnSendSitrep(20,TRUE)}
	       CASE 4:{fnSendSitrep(10,TRUE)}
	       }
	  }
     }
     
     
    
     //if (sLicenseKey.cLicenseKey != CLIENT_LICENSE_STRING)GRIFFITH-ZBX55DB4S17-VAV
     (*
     if (CLIENT_LICENSE_STRING != 'GRIFFITH-ZBX55DB4S17-VAV')
	  {
	  if (sLicenseData.nLicenseDay == 0 || sLicenseData.nLicenseYear == 0 || sLicenseData.nLicenseMonth == 0)
	       {
	       //fnWx_DeBug(
		    {
		    SEND_STRING 0,"'License Expiration Key "Zero Values: Day ',itoa(sLicenseData.nLicenseDay),
									   ', Month ',itoa(sLicenseData.nLicenseMonth),
									   ', Year ',itoa(sLicenseData.nLicenseYear),
									   ' >-:DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
		    }
	       fnWeather_LoadStoredValues(LICENSE_DATA_FILENAME,cWeather_Var_to_XML,'DATA') ;
	       clear_buffer cWeather_Var_to_XML ;
	       fnWeather_LoadStoredValues(LICENSE_KEY_FILENAME,cWeather_Var_to_XML,'KEY') ;
	       clear_buffer cWeather_Var_to_XML ;
	       }
	  if (sLicenseData.nLicenseDay != DATE_TO_DAY(LDATE))
	       {
	       //fnWx_DeBug(
		    {
		    SEND_STRING 0,"'License Expiration New Day, day: "',sLicenseData.nLicenseDay,'"! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
		    }
	       fnWeather_LoadStoredValues(LICENSE_KEY_FILENAME,cWeather_Var_to_XML,'KEY') ;
	       clear_buffer cWeather_Var_to_XML ;
	       if (sLicenseKey.cLicenseKey == CLIENT_LICENSE_STRING)
		    {
		    //fnWx_DeBug(
			 {
			 SEND_STRING 0,"'License Expiration Key "Key Matched", Key Entered: "',sLicenseKey.cLicenseKey,'"! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			 }
		    sLicenseData.nLicenseDLFlag = 0 ;
		    sLicenseData.nLicenseDayCountDown = 0
		    }
	       sLicenseData.nLicenseDay = DATE_TO_DAY(LDATE) ;
	       sLicenseData.nLicenseMonth = DATE_TO_MONTH(LDATE) ;
	       sLicenseData.nLicenseYear = DATE_TO_YEAR(LDATE) ;
	       if (!sLicenseData.nLicenseDLFlag && sLicenseKey.cLicenseKey != CLIENT_LICENSE_STRING)
		    {
		    if (LDATE == LICENSE_EXPIRATION_DATE)
			 {
			 sLicenseData.nLicenseDLFlag = 1 ;
			 sLicenseData.nLicenseDayCountDown = 30 ;
			 //fnWx_DeBug(
			      {
			      SEND_STRING 0,"'License Expiration Date Match String: "',LICENSE_EXPIRATION_DATE,'"! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			      }
			 }
		    else if (sLicenseData.nLicenseYear >= LICENSE_EXPIRATION_YEAR && sLicenseData.nLicenseMonth >= LICENSE_EXPIRATION_MONTH )
			 {
			 sLicenseData.nLicenseDLFlag = 1 ;
			 sLicenseData.nLicenseDayCountDown = 30 ;
			 //fnWx_DeBug(
			      {
			      SEND_STRING 0,"'License Expiration Date Match Constants: ',itoa(LICENSE_EXPIRATION_YEAR),' & ',
										itoa(LICENSE_EXPIRATION_MONTH ),'" <-:DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			      }
			 }
		    }
	       else if (sLicenseData.nLicenseDLFlag && sLicenseData.nLicenseDayCountDown > 0)
		    {
		    stack_var sinteger nWeatherKey_Var_to_XML ;
		    stack_var long nWeatherEncodePOS ;
		    
		    sLicenseData.nLicenseDayCountDown -- ;
		    sLicenseData.nLicenseHour = TIME_TO_HOUR(TIME) ;
		    sLicenseData.nLicenseMinute = TIME_TO_MINUTE(TIME) ;
		    nWeatherEncodePOS = 1 ;
		    nWeatherKey_Var_to_XML = VARIABLE_TO_XML(sLicenseData,cWeather_Var_to_XML,nWeatherEncodePOS,0 ) ;
		    //fnWx_DeBug(
			 {
			 SEND_STRING 0,"'WeatherKey Writing to File! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			 }
		    fnFileWrite_ToFile(LICENSE_DATA_FILENAME,cWeather_Var_to_XML) ;
		    clear_buffer cWeather_Var_to_XML ;
		    //fnWx_DeBug(
			 {
			 SEND_STRING 0,"'WeatherKey sending to TPs! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			 }
		    SEND_COMMAND dvTP_Array,"'!T',3,itoa(sLicenseData.nLicenseDayCountDown),' day left !'" ;
		    SEND_COMMAND dvTP_Array,"'PPON-LicenseExpiring'" ;
		    }
	       }
	  else if (sLicenseData.nLicenseDLFlag && sLicenseData.nLicenseDayCountDown == 0)
	       {
	       if (sLicenseData.nLicenseHour != TIME_TO_HOUR(TIME))
		    {
		    stack_var sinteger nWeatherKey_Var_to_XML ;
		    stack_var long nWeatherEncodePOS ;
		    
		    fnWeather_LoadStoredValues(LICENSE_KEY_FILENAME,cWeather_Var_to_XML,'KEY') ;
		    if (sLicenseKey.cLicenseKey != CLIENT_LICENSE_STRING)
			 {
			 sLicenseData.nLicenseHour = TIME_TO_HOUR(TIME) ;
			 //fnWx_DeBug(
			      {
			      SEND_STRING 0,"'License Expiration New Hour, hour: "',sLicenseData.nLicenseHour,'"! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			      }
			 nWeatherEncodePOS = 1 ;
			 nWeatherKey_Var_to_XML = VARIABLE_TO_XML(sLicenseData,cWeather_Var_to_XML,nWeatherEncodePOS,0 ) ;
			 //fnWx_DeBug(
			      {
			      SEND_STRING 0,"'WeatherKey Writing to File! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			      }
			 fnFileWrite_ToFile(LICENSE_DATA_FILENAME,cWeather_Var_to_XML) ;
			 clear_buffer cWeather_Var_to_XML ;
			 //fnWx_DeBug(
			      {
			      SEND_STRING 0,"'License Key Hour = ',itoa(sLicenseData.nLicenseHour),' ! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			      SEND_STRING 0,"'License Key "wait 20" & Reboot Master! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			      }
			 wait 20
			      {
			      REBOOT (0:1:0) ;
			      }
			 }
		    }
	       else if (sLicenseData.nLicenseMinute != TIME_TO_MINUTE(TIME))
		    {
		    sLicenseData.nLicenseMinute = TIME_TO_MINUTE(TIME) ;
		    fnWeather_LoadStoredValues(LICENSE_KEY_FILENAME,cWeather_Var_to_XML,'KEY') ;
		    if (sLicenseKey.cLicenseKey != CLIENT_LICENSE_STRING)
			 {
			 //fnWx_DeBug(
			      {
			      SEND_STRING 0,"'License Expiration New Minute, minute: "',itoa(sLicenseData.nLicenseMinute),'"! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
			      }
			 if (sLicenseData.nLicenseMinute == 30)
			      {
			      //fnWx_DeBug(
				   {
				   SEND_STRING 0,"'WeatherKey update TPs with Pop-Up left = ',itoa(sLicenseData.nLicenseDayCountDown),' days! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
				   }
			      SEND_COMMAND dvTP_Array,"'!T',3,itoa(sLicenseData.nLicenseDayCountDown),' days left !'" ;
			      SEND_COMMAND dvTP_Array,"'PPON-LicenseExpiring'" ;
			      }
			 else if (sLicenseData.nLicenseMinute == 45)
			      {
			      stack_var integer nNumTPs ;
			      stack_var integer nTP ;
			      
			      //fnWx_DeBug(
				   {
				   SEND_STRING 0,"'WeatherKey Reboot TP!!!! :DEBUG<',ITOA(__LINE__),'>',STR_CRLF" ;
				   }
			      nNumTPs = length_array(dvTP_Array)
			      for (nTP = 1 ; nTP <= nNumTPs ; nTP ++)
				   {
				   REBOOT (dvTP_Array[nTP]) ;
				   }
			      }
			 }
		    }
	       }
	  }
     }
     *)
