﻿PROGRAM_NAME='VAV_SYSTEM_CONSTANTS'

#DEFINE VAV_SYSTEM_CONSTANTS

DEFINE_CONSTANT //GENERAL COUNTS, UI's, 

#DEFINE NUMBER_COUNTS_CONSTANTS

//NUM_UIs_IN_SYSTEM	= 15 ;
NUM_MASTERs_SYSTEM	= 1 ; 
MASTER			= 0 ;
DEV_MASTER		= 0 ;
UI_DETERMINE_BOOT_BTN   = 100 ;//PORT 1 BTN 100

DEFINE_CONSTANT //LIST SIZES FOR UI's

#DEFINE LIST_SIZE_UIs_CONSTANTS

LIST_SIZE_TP   		= 10 ;
LIST_SIZE_R4	  	= 5 ;
LIST_SIZE_DMS  		= 5 ;

DEFINE_CONSTANT //POP UP PARAMETERS

#DEFINE POP_UP_CONSTANTS

POPON			= 1 ;
POPOFF			= 0 ;

DEFINE_CONSTANT //CHANNEL CONSTANTS. ON, OFF, PULSE

#DEFINE CHANNEL_CONSTANTS

CH_OFF			= 0 ;
CH_ON			= 1 ;
CH_PULSE		= 2 ;
CH_TOGGLE		= 3 ;

DEFINE_CONSTANT // RECON TIMES

CHAR DEV_RECON_IN_0		= 0 ;
CHAR DEV_RECON_IN_5s		= 5 ;
CHAR DEV_RECON_IN_10s		= 10 ;
CHAR DEV_RECON_IN_30s		= 30 ;
CHAR DEV_RECON_IN_1m		= 60 ;

DEFINE_CONSTANT // TIMELINE CNSTANTS

CHAR TIMELINE_IS_KILLED		= 0 ;
CHAR TIMELINE_IS_ACTIVE		= 1 ;
CHAR TIMELINE_IS_PAUSED		= 2 ;

CHAR TIMELINE_DO_KILL		= 0 ;
CHAR TIMELINE_DO_CREATE		= 1 ;
CHAR TIMELINE_DO_PAUSE		= 2 ;
CHAR TIMELINE_DO_RESTART	= 3 ;
CHAR TIMELINE_DO_RELOAD		= 4 ;
CHAR TIMELINE_DO_SET		= 5 ;

DEFINE_CONSTANT //DO PUSH TIMED VALUES

DO_PUSH_TIMED_5S_MAX 	= 50 ;
DO_PUSH_TIMED_10S_MAX 	= 100 ;
DO_PUSH_TIMED_30S_MAX 	= 300 ;
DO_PUSH_TIMED_1M_MAX 	= 600 ;
DO_PUSH_TIMED_5M_MAX 	= 3000 ;

DEFINE_CONSTANT //DEBUG VALUES

CHAR DEBUG_OFF		= 0 ;
CHAR DEBUG_AXI_ONLY	= 1 ;
CHAR DEBUG_MOD_ONLY	= 2 ;
CHAR DEBUG_BOTH_AXI_MOD	= 3 ;

DEFINE_CONSTANT //GENERAL STRING PARTS (CRLF, LF, CR, ETC.) 

#DEFINE STR_CONSTANTS

CHAR STR_CRLF[2] 	= {$0D,$0A}
CHAR STR_CR[]  		= {$0D} ;
CHAR STR_LF[]		= {$0A} ;
CHAR STR_SPACE[]	= {$20} ;
CHAR STR_STX[]		= {$02} ;
CHAR STR_ETX[]		= {$03} ;
CHAR STR_SEMI_COLON[]	= {$3B} ;
CHAR STR_COMMA[]	= {$2C} ;
CHAR STR_NULL[]		= {$00} ;

CHAR STR_QUEUE_HEAD	= 1 ;
CHAR STR_QUEUE_TAIL	= 0 ;

DEFINE_CONSTANT //COMM TYPES

CHAR COMM_IS_SERIAL	= $FF ;
CHAR COMM_IS_IP 	= $FA ;
CHAR COMM_IR_NO_LINK	= 0 ;
CHAR COMM_IR_LINK_1	= 1 ;
CHAR COMM_IR_LINK_2	= 2 ;
CHAR COMM_IR_LINK_3	= 3 ;
CHAR COMM_IR_LINK_4	= 4 ;
CHAR COMM_IR_LINK_5	= 5 ;
CHAR COMM_IR_LINK_6	= 6 ;
CHAR COMM_IR_LINK_7	= 7 ;
CHAR COMM_IR_LINK_8	= 8 ;

DEFINE_CONSTANT //IP CONNECTION TYPES 

CHAR IP_TYPE_TCP	= 1 ;
CHAR IP_TYPE_UDP      	= 2 ;
CHAR IP_TYPE_UDP_w_RX	= 3 ;

DEFINE_CONSTANT //CLIENT CONNECTIONS 

#DEFINE IP_CLIENT_CONSTANTS

CHAR IP_CLIENT_DISABLED		= 0 ;
CHAR IP_CLIENT_DISCO		= 1 ;
CHAR IP_CLIENT_PENDING		= 2 ;
CHAR IP_CLIENT_CONNECTED	= 3 ;
CHAR IP_CLIENT_DEVICE_READY	= 4 ;
CHAR IP_CLIENT_RX_DATA		= 5 ;
CHAR IP_CLIENT_TX_DATA		= 6 ;

DEFINE_CONSTANT //SERVER CONNECTIONS

#DEFINE IP_SERVER_CONSTANTS

CHAR IP_SERVER_DISABLED	= 0 ;
CHAR IP_SERVER_STOPPED	= 1 ;
CHAR IP_SERVER_PENDING	= 2 ;
CHAR IP_SERVER_LISTENING= 3 ;
CHAR IP_SERVER_CONNECTED= 4 ;
CHAR IP_SERVER_RX_DATA	= 5 ;
CHAR IP_SERVER_TX_DATA	= 6 ;

DEFINE_CONSTANT //IP CONSTANTS

#DEFINE IP_CONSTANTS

CHAR IP_LENGTH_IP_STR	= 15 ;
CHAR IP_CLIENT_ONLINE	= 1 ;
CHAR IP_CLIENT_OFFLINE	= 0 ;
CHAR IP_SERVER_ONLINE	= 1 ;
CHAR IP_SERVER_OFFLINE	= 0 ;
CHAR IP_PROTOCOL_TCP    = 1 ;
CHAR IP_PROTOCOL_UDP    = 2 ;

DEFINE_CONSTANT //CUSTOM EVENT ID'S

#DEFINE CUSTOM_EVENT_IDs

CUSTOM_EVENTID_BTNTXT	= 1001 ;
(*
CUSTOM_EVENT[TP,529,1001]      // Text
CUSTOM_EVENT[TP,529,1002]      // Bitmap
CUSTOM_EVENT[TP,529,1003]      // Icon
CUSTOM_EVENT[TP,529,1004]      // Text Justification
CUSTOM_EVENT[TP,529,1005]      // Bitmap Justification
CUSTOM_EVENT[TP,529,1006]      // Icon Justification
CUSTOM_EVENT[TP,529,1007]      // Font
CUSTOM_EVENT[TP,529,1008]      // Text Effect Name
CUSTOM_EVENT[TP,529,1009]      // Text Effect Color
CUSTOM_EVENT[TP,529,1010]      // Word Wrap
CUSTOM_EVENT[TP,529,1011]      // ON state Border Color
CUSTOM_EVENT[TP,529,1012]      // ON state Fill Color
CUSTOM_EVENT[TP,529,1013]      // ON state Text Color
CUSTOM_EVENT[TP,529,1014]      // Border Name
CUSTOM_EVENT[TP,529,1015]      // Opacity
*)

DEFINE_CONSTANT //UI CONSTANTS & TYPES (Unknown=1, KP=2, R4=3, G3=4, G4=5) 

#DEFINE UI_TYPE_CONSTANTS

CHAR UI_OFF_PAGE	= 0 ;
CHAR UI_ON_PAGE		= 1 ;
 
CHAR UI_BTN_OFFPAGE	= 200 ;
CHAR UI_BTN_ONPAGE	= 201 ;
CHAR UI_ONPAGE_MAIN	= 0 ;
CHAR UI_ONPAGE_GEN_BASE	= 0 ;
CHAR UI_ONPAGE_AUD_BASE	= 100 ;
CHAR UI_ONPAGE_A_V_BASE	= 200 ;

CHAR UI_OFF_ON_LINE	= 1 ;
CHAR UI_REBOOTED	= 2 ;
CHAR UI_INITIALIZED	= 3 ;
//DO NOT CHANGE ORDER
CHAR UI_UPDATE_ACTIVE 	= 0 ;//OTHERWISE THE UI INDEX IS REQUIRED
CHAR UI_TYPE_ZERO_OFFLINE = 0 ;
CHAR UI_TYPE_UNKNOWN    = 1 ;
CHAR UI_TYPE_VIRTUAL	= 2 ;
CHAR UI_TYPE_METKP	= 3 ;
CHAR UI_TYPE_MIO_DMS	= 4 ;
CHAR UI_TYPE_G3		= 5 ;
CHAR UI_TYPE_R4		= 6 ;
CHAR UI_TYPE_G4		= 7 ;
CHAR UI_TYPE_iPHONE	= 8 ;
CHAR UI_TYPE_iPAD	= 9 ;
CHAR UI_TYPE_iTOUCH	= 10 ;
                        
CHAR UI_RESI_1024x768	= 107 ;
CHAR UI_RESI_1280x768	= 127 ;
CHAR UI_RESI_800x600	= 86 ;
CHAR UI_RESI_800x480	= 84 ;
CHAR UI_RESI_480x320	= 43 ;
CHAR UI_RESI_480x272	= 42 ;
CHAR UI_RESI_272x480	= 24 ;
CHAR UI_RESI_320x240    = 34
CHAR UI_RESI_NO_PICS	= 0 ;
   
CHAR UI_TYPE[][10] = 

     {
     'Unknown',			//1
     'Virtual',                 //2
     'Keypad',			//3
     'Mio_DMS',			//4
     'G3 Panel',		//5
     'R4 Remote',		//6
     'G4 Panel', 		//7
     'TPC_iPhone',              //8
     'TPC_iPad',                //9
     'TPC_iTouch'               //10
     } ;                        

DEFINE_CONSTANT //UI CONSTANTS & TYPES (Unknown=1, KP=2, R4=3, G3=4, G4=5) 

#DEFINE METKP_TYPE_CONSTANTS

CHAR METKP_TYPE_MET6N	= 1 ;
CHAR METKP_TYPE_MET7	= 2 ;
CHAR METKP_TYPE_MET13	= 3 ;

DEFINE_CONSTANT //DEVICE ID's 

#DEFINE DEV_ID_CONSTANTS     

/////////////////////////////////KEYPADS NO TEXT SUPPORT

DEV_ID_METKP_BEGIN	= 169 ;
DEV_ID_MET6N  		= 169 ;
DEV_ID_MET7   		= 170 ;
DEV_ID_MET13  		= 171 ;
DEV_ID_METKP_END	= 171 ;

/////////////////////////////////KEYPADS MIO DMS TEXT & UNI SUPPORT

DEV_ID_MIO_DMS_BEGIN	= 304 ;
DEV_ID_MIO_DMS1		= 304 ; //Mio-DMS Keypad (non-color, non-touch display with buttons)
DEV_ID_MIO_DMS2		= 305 ; //Mio-DMS Keypad (non-color display with touch and slider)
DEV_ID_MIO_DMS3		= 306 ; //Mio-DMS Keypad (color display with touch and slider)
DEV_ID_MIO_DMS4		= 307 ; //Mio-DMS Keypad (color display with touch, slider, and intercom)
DEV_ID_MIO_DMS_END	= 307 ;

/////////////////////////////////G3 PANELS 

DEV_ID_G3_END		= 256 ;

/////////////////////////////////G4 PANELS 

DEV_ID_CA15		= 281 ; //NXx-CA15
DEV_ID_CV15		= 282 ; //NXx-CV15
DEV_ID_CA17		= 283 ; //NXx-CA17
DEV_ID_CV17		= 284 ; //NXx-CV17

DEV_ID_7500 		= 288 ; //MVP-7500
DEV_ID_8400 		= 289 ; //MVP-8400
DEV_ID_CV7 		= 290 ; //NXx-CV7
DEV_ID_CV10 		= 291 ; //NXx-CV10
     
DEV_ID_1200 		= 294 ; //NXx-1200
DEV_ID_12VG 		= 295 ; //NXx-1200VG
DEV_ID_15VG 		= 296 ; //NXx-1500VG
DEV_ID_17VG 		= 297 ; //NXx-1700VG

DEV_ID_CV5		= 313 ; //NXD-CV5
DEV_ID_7500TC		= 314 ; //MVP-7500 with Touch Controller
DEV_ID_8400TC		= 315 ; //MVP-8400 with Touch Controller
DEV_ID_CV7TC		= 316 ; //NXx-CV7 with Touch Controller
DEV_ID_CV10TC		= 317 ; //NXx-CV10 with Touch Controller
DEV_ID_12TC		= 318 ; //NXx-1200 with Touch Controller
DEV_ID_12VGTC		= 319 ; //NXx-1200VG with Touch Controller
DEV_ID_15VGTC		= 320 ; //NXx-1500VG with Touch Controller
DEV_ID_17VGTC		= 321 ; //NXx-1700VG with Touch Controller

/////////////////////////////////R4 

DEV_ID_R4		= 322 ;

/////////////////////////////////CONT G4 PANELS 

DEV_ID_8400i		= 323 ; //MVP-8400i
DEV_ID_CV7iTC		= 324 ; //NXx-CV7i with Touch Controller
DEV_ID_CV10iTC		= 325 ; //NXx-CV10i with Touch Controller

DEV_ID_5200i 		= 329 ;
DEV_ID_5150 		= 329 ;
DEV_ID_5100 		= 329 ;
DEV_ID_500i 		= 331 ;
DEV_ID_9000i 		= 343 ;
DEV_ID_iPHONE		= 347 ;
DEV_ID_iPAD		= 348 ;
DEV_ID_iTOUCH		= 349 ;

DEV_ID_430		= $6500 ; //presently unknown
DEV_ID_435		= $6501 ; //presently unknown
DEV_ID_435P		= $6502 ; //presently unknown

/////////////////////////////////NI MASTERS

DEV_ID_NI2_3_4000_M	= 285 ; //NI-2000/3000/4000 (Master)
DEV_ID_NI2_3_4000_D	= 286 ; //NI-2000/3000/4000 (Device)


DEV_ID_NI700		= 298 ; //NI-700                             
DEV_ID_NI2_3_4000	= 299 ; //NI-2000/3000/4000 
DEV_ID_NI900		= 312 ; //NI-900

                                
/////////////////////////////////ENT VST - C 

DEV_ID_ENVVSTC 		= $E5 ;

DEV_iTPC_UI_START	= 10000 ;
DEV_iTPC_UI_END		= 11000 ;

DEV_ID_VIRTUAL		= 65534 ;

DEFINE_CONSTANT //ERROR FLAGS

CHAR ERR_SOURCE_INVALID		= 10 ;
CHAR ERR_DISPLAY_INVALID	= 11 ;
CHAR ERR_UPLINK_INVALID		= 12 ;
CHAR ERR_RESPON_INVALID		= 13 ;
CHAR ERR_PWORD_INVALID		= 14 ;
CHAR ERR_PWORD_TIMEOUT		= 15 ;
CHAR ERR_NOT_CONNECTED		= 16 ;
CHAR ERR_NO_ACTIVE_UI		= 17 ;
CHAR ERR_NO_RESPONSE		= 18 ;
CHAR ERR_FORCE_RECON		= 19 ;
CHAR ERR_RECON_OK		= 20 ;
CHAR ERR_RECON_FAILED		= 21 ;