﻿PROGRAM_NAME='VAV_SITREP_ModClient'

#DEFINE SITREP_MOD_CLIENT

//changes to this file requires these to be re-compliled
//used by 'VAV_!MyWeatherMod1'
//used by 'DevTermLogger'
#WARN 'changes to VAV_SITREP_ModClient requires module re-compile!'

DEFINE_DEVICE

//here for reference. pass into module as parameter to ensure it's always correct!!!
//vSitrep_Client		= 33031:1:0 ;

DEFINE_CONSTANT

CHAR SITREP_USER[100]		= 'user' ;//match devmon.axi and Sitrep_Server.axi
CHAR SITREP_PASS[100]		= 'passsword' ; 
CHAR SITREP_DEFAULT_URL[]	= 'yourdns.dyndns.org' ;

DEFINE_TYPE //MESSAGE QUEUE

STRUCTURE _sSitrepMsg //match the VAV_SitRep_Client structure

     {
     CHAR cTask[256] ;
     CHAR cFrom[256] ;
     CHAR cURL[256] ;
     CHAR cUser[128] ;
     CHAR cPass[128] ;
     CHAR cSubj[256] ;
     CHAR cBody[4096] ;
     CHAR cFile[256] ;
     CHAR cTime[8] ;
     CHAR cLDate[10] ;
     }
     
DEFINE_VARIABLE

VOLATILE INTEGER nSitRepModClient_DeBug = 0 ;
//#WARN 'nSitRepModClient_DeBug = 1'
     
DEFINE_FUNCTION fnSitrepModClient_DeBug(CHAR iStr[])

     {
     if(nSitRepModClient_DeBug)
	  {
	  STACK_VAR CHAR cCopyStr[1024] ;
	  STACK_VAR INTEGER nLineCount ;
	  
	  cCopyStr = iStr ;
	  
	  nLineCount ++ ;
	  WHILE(length_string(cCopyStr) > 80)
	       {
	       SEND_STRING 0,"'SITREP_MODClient.axi (',itoa(nLineCount),') DEBUG: ',get_buffer_string(cCopyStr,80)" ;
	       nLineCount ++
	       }
	  if(length_string(cCopyStr))
	       {
	       SEND_STRING 0,"'SITREP_MODClient.axi (',itoa(nLineCount),') DEBUG: ',cCopyStr" ;
	       }
	  }
     
     RETURN ;
     } 
     
DEFINE_FUNCTION CHAR[8192] fnSitrepMod_VarToStr(_sSitrepMsg iSitrepMsg)
     
     {
     STACK_VAR LONG nPos ;
     STACK_VAR SINTEGER nResult;
     STACK_VAR CHAR cEncoded[8192] ;
     
     nPos = 1 ;
     nResult = VARIABLE_TO_STRING(iSitrepMsg,cEncoded,nPos) ;
     if(nResult == 0)// Success
	  {
	  fnSitrepModClient_DeBug("'RX_Msg, Rx VarToStr encode OK! ',itoa(length_string(cEncoded)),' byte str :DEBUG<',ITOA(__LINE__),'>'") ;
	  RETURN cEncoded ;
	  }
     else// Failure
	  {
	  fnSitrepModClient_DeBug("'RX_Msg, Rx Variable To String encode ERR# (',itoa(nResult),') :DEBUG<',ITOA(__LINE__),'>'") ;
	  RETURN '' ;
	  }
     }     
     
DEFINE_FUNCTION SLONG fnSitrepQueMSG(CHAR iTask[],CHAR iFrom[],CHAR iURL[],CHAR iUser[],CHAR iPass[],CHAR iSubject[],CHAR iBody[],CHAR iFile[])

     {
     LOCAL_VAR _sSitrepMsg sSitrepMsg ;
     STACK_VAR CHAR cReturn[8192] ;
     
     sSitrepMsg.cTask   	= iTask ;
     sSitrepMsg.cFrom   	= iFrom ;
     sSitrepMsg.cURL      	= iURL ;
     sSitrepMsg.cUser		= iUser ;
     sSitrepMsg.cPass     	= iPass ;
     sSitrepMsg.cSubj    	= iSubject ;
     sSitrepMsg.cBody     	= iBody ;
     sSitrepMsg.cFile		= iFile ;
     sSitrepMsg.cTime     	= '' ; //TIME ; not used do why bother//set on the other side
     sSitrepMsg.cLDate    	= '' ; //LDATE ; 

     cReturn = fnSitrepMod_VarToStr(sSitrepMsg) ;
     if(length_string(cReturn))
	  {
	  SEND_STRING vSitrep_Client,"1,cReturn" ;
	  }
     }
////////////////////////////////////////////////////////

////////////////////////////////////////////////////////

////////////////////////////////////////////////////////

////////////////////////////////////////////////////////     
